<template>
  <v-main justify="center" class="py-10">
    <v-row justify="center">
      <v-col cols="10" class="offset-1">
        <h1 class="display-2 text-xs-center primary--text mb-4">
          Identidad Digital
        </h1>
      </v-col>
      <v-col v-if="loading" cols="10" class="offset-1 height-full text-center">
        <h1>Estamos buscando tu certificado</h1>
        <v-row
          v-load="loading"
          load-background="white"
          load-type="folding-cube"
          class="mt-15"
        ></v-row>
      </v-col>
      <v-col
        v-if="certificate.is_certified"
        cols="12"
        sm="11"
        md="9"
        lg="8"
        xl="6"
        mb-3
        elevation-1
      >
        <v-card elevation="2" class="pa-6 pa-sm-8">
          <v-row class="template-boder">
            <v-col cols="12" align="center" justify="center" class="mt-5 mb-15">
              <h1 class="font-weight-regular display-2 primary--text">
                Esta es tu
                <br />
                <span class="font-weight-bold">Identidad</span> Digital
              </h1>
            </v-col>
            <v-col
              cols="12"
              md="6"
              :style="backgroundQR"
              align="center"
              justify="center"
              class="mt-5"
            >
              <vue-qrcode
                :value="certificate.link"
                :width="20"
                :margin="4"
                :scale="5"
              ></vue-qrcode>
            </v-col>
            <v-col cols="12" md="6" class="grey--text text--darken-2 mt-5">
              <h1 class="mb-5">{{ certificate.name_citizen }}</h1>
              <h3 class="font-weight-regular mb-5">
                <v-icon medium color="primary" class="mr-2">
                  mdi-account-outline
                </v-icon>
                DNI No.
                <span class="font-weight-bold" style="word-break: break-all">{{
                  certificate.dni
                }}</span>
              </h3>
              <h3 class="mb-5">
                <v-icon medium color="primary" class="mr-2">
                  mdi-email-outline
                </v-icon>
                <span class="font-weight-bold" style="word-break: break-all">{{
                  certificate.email
                }}</span>
              </h3>
              <h3 class="mb-5">
                <v-icon medium color="primary" class="mr-2">
                  mdi-fingerprint
                </v-icon>
                <span class="font-weight-bold" style="word-break: break-all">{{
                  certificate.public_address
                }}</span>
              </h3>
            </v-col>
            <v-col
              cols="12"
              class="white--text px-8 px-sm-10 mt-15 py-6 info-json"
            >
              <p class="mb-0">
                Este certificado fue firmado digitalmente en la Blockchain de
                <span class="font-weight-bold">{{ certificate.chain }}</span>
              </p>
              <p class="mb-0">
                ID Emisor
                <a
                  :href="certificate.issuerID"
                  target="_blank"
                  class="font-weight-bold white--text"
                  >{{ certificate.issuerID }}</a
                >
              </p>
              <p class="mb-0">
                Fecha de certificación
                <span class="font-weight-bold">{{
                  certificate.issuedOnFormat
                }}</span>
              </p>
              <p class="mb-0">
                ID de transacción en Blockchain
                <span class="font-weight-bold">{{
                  certificate.transactionIDURL
                }}</span>
              </p>
              <p class="mb-0">
                Hash único de certificado
                <span class="font-weight-bold">{{ certificate.hash }}</span>
              </p>
              <p class="mb-0">
                Llave única de certificado
                <a
                  :href="urlFile"
                  target="_blank"
                  class="font-weight-bold white--text"
                  >{{ certificate.uuid }}</a
                >
              </p>
            </v-col>
            <v-col cols="12" class="py-8 pl-10">
              <v-btn
                :disabled="!isCertificateFull"
                small
                tile
                color="primary"
                @click="verify(certificate)"
                >Verificar</v-btn
              >
              <template v-if="verificationResult.status === 'success'">
                <v-icon color="green">mdi-check-decagram</v-icon>
                <p class="d-inline">Verificado</p>
              </template>
              <template v-else-if="verificationResult.status === 'failure'">
                <v-icon color="red">mdi-alert-decagram</v-icon>
                <p class="d-inline">
                  El certificado no ha podido ser verificado
                </p>
              </template>
            </v-col>
            <v-col>
              <template v-if="uniqueVerificationStepOne.length > 0">
                <hr class="my-5 verificationDivider" />
                <p class="font-weight-bold">
                  Paso 1 de 4 - Verificando Alteración:
                  <v-icon v-if="checkVerifierFirstStep === true" color="green"
                    >mdi-check-decagram</v-icon
                  >
                  <v-icon
                    v-else-if="checkVerifierFirstStep === 'failure'"
                    color="red"
                    >mdi-alert-decagram</v-icon
                  >
                  <v-icon v-else>mdi-dots-circle</v-icon>
                </p>
                <p
                  v-for="(step, index) in uniqueVerificationSteps"
                  :key="index"
                  class="font-weight-bold"
                >
                  {{ `Paso ${index + 2} de 4 - ${step.label}: ` }}
                  <v-icon v-if="step.status === 'success'" color="green"
                    >mdi-check-decagram</v-icon
                  >
                  <v-icon v-else-if="step.status === 'starting'"
                    >mdi-dots-circle</v-icon
                  >
                  <v-icon v-else color="red">mdi-alert-decagram</v-icon>
                </p>
                <template v-if="verificationResult.message">
                  <p
                    v-if="verificationResult.message.label === 'Verificado'"
                    class="font-weight-bold"
                  >
                    ¡Éxito! El certificado ha sido verificado.
                  </p>
                  <p v-else>
                    {{
                      `El certificado no ha podido ser verificado. Error: ${verificationResult.message}`
                    }}
                  </p>
                </template>
                <hr class="my-5 verificationDivider" />
              </template>
            </v-col>
          </v-row>
        </v-card>
      </v-col>
      <v-snackbar
        v-model="snackbar.show"
        :top="true"
        :right="true"
        :timeout="snackbar.timeout"
        :color="snackbar.color"
        :multi-line="snackbar.mode === 'multi-line'"
        :vertical="snackbar.mode === 'vertical'"
      >
        {{ snackbar.text }}
        <v-btn
          icon
          class="float-right"
          justify="center"
          align="center"
          @click.native="snackbar.show = false"
        >
          <v-icon>mdi-close</v-icon>
        </v-btn>
      </v-snackbar>
    </v-row>
  </v-main>
</template>

<script lang="ts">
import moment from 'moment'
import * as Papa from 'papaparse'
import { mapGetters } from 'vuex'
import _ from 'lodash'
import VueQrcode from 'vue-qrcode'

import {
  BlockcertsCertificate,
  setCertificate,
  updateCertificate,
  CertificateToBlockcerts,
} from '@/services/Certificates'
import { saveFile } from '~/services/Firebase'
import CertificateMixin from '@/mixins/CertificateMixin'

export default CertificateMixin.extend({
  components: { VueQrcode },
  middleware: ['completedata'],
  data() {
    return {
      // loadingCertificate: true,
      firstStepVerification: [] as any,
      uniqueVerificationSteps: [] as any,
      uniqueVerificationStepOne: [] as any,
      loading: false,
      hasName: false,
      firebaseCollection: 'certificates',
      certificate: {} as any,
      blockcertsCertificate: {} as BlockcertsCertificate,
      redirect: '/citizen/certificates/',
      refCertContributor: true,
      data: Object(),
      urlFile: '',
      snackbar: {
        show: false,
        color: '',
        mode: '',
        timeout: 6000,
        text: '',
        right: '',
        top: '',
      },
    }
  },
  watch: {
    verificationSteps(value: any): any {
      const firstStepValues = [
        'getTransactionId',
        'computeLocalHash',
        'fetchRemoteHash',
        'getIssuerProfile',
        'parseIssuerKeys',
        'compareHashes',
        'checkMerkleRoot',
        'checkReceipt',
      ]

      this.firstStepVerification = this.verificationSteps.filter((item: any) =>
        firstStepValues.includes(item.code)
      )

      if (this.verificationSteps.length <= 16) {
        const index = this.uniqueVerificationStepOne.findIndex(
          (step: any) => step.code === value.at(-1).code
        )
        if (index !== -1) {
          this.uniqueVerificationStepOne[index].status = value.at(-1).status
        } else {
          this.uniqueVerificationStepOne.push(value.at(-1))
        }
      }

      const index = this.uniqueVerificationSteps.findIndex(
        (step: any) => step.code === value.at(-1).code
      )
      if (index !== -1) {
        this.uniqueVerificationSteps[index].status = value.at(-1).status
      } else {
        this.uniqueVerificationSteps.push(value.at(-1))
      }

      this.uniqueVerificationSteps = this.uniqueVerificationSteps.filter(
        (item: any) => !firstStepValues.includes(item.code)
      )
    },
  },
  computed: {
    isCertificateFull(): any {
      return 'transactionIDURL' in this.certificate
    },
    checkVerifierFirstStep(): any {
      const firstStepStatus = this.uniqueVerificationStepOne.some(
        (step: any) => step.status === 'failure'
      )

      if (firstStepStatus) {
        return 'failure'
      } else {
        return this.uniqueVerificationStepOne.every(
          (step: any) => step.status === 'success'
        )
      }
    },
    ...mapGetters({
      userStore: 'users/user',
      certsConfig: 'certsConfig/certsConfig',
      brand: 'brand/brand',
    }),
    backgroundQR(): any {
      return {
        'background-image': `url('${this.brand.qrImage}')`,
        'background-position': 'center',
      }
    },
  },
  mounted() {
    this.getCertificateByLink()
  },
  methods: {
    createCsv(element: any): any {
      const fullData: BlockcertsCertificate[] = []
      // Remove ref and estado_origen from original certificate
      const finalCertficate = CertificateToBlockcerts(element)
      fullData.push(finalCertficate)
      const i = Papa.unparse(fullData)
      const file = new Blob(['\uFEFF', i], {
        type: 'data:text/csv;charset=utf-8',
      }) as any
      const date = moment().format('YYYY_MM_DD_HH_mm')
      file.name = `certificates_${date}.csv`
      saveFile(this.$fireModule, file, 'certificates')
    },
    async certificateData(): Promise<void> {
      this.data = _.merge(this.data, this.userStore)
      this.data.identity = this.certsConfig.identity
      this.data.name = `${this.userStore.first_name} ${this.userStore.last_name}`
      this.data.name_citizen = `${this.userStore.first_name} ${this.userStore.last_name}`
      this.data.pubkey = this.userStore.public_address
        ? `ecdsa-koblitz-pubkey:${this.userStore.public_address}`
        : `ecdsa-koblitz-pubkey:${this.certsConfig.pubkey}`
      this.data.estado_origen = 'En espera'
      this.data.type = 'digital-identity'
      this.data.title = 'Ciudadano Digital'
      this.data.created = moment().format()
      this.data.id_user = this.userStore.uid
      delete this.data.password
      delete this.data.tipoPersona
      delete this.data.autenticated
      delete this.data.activated
      delete this.data.uid
      delete this.data.first_name
      delete this.data.last_name
      delete this.data.levelUp
      delete this.data.keyCopyConfirmed
      const idCert = await setCertificate(this.$fire, this.data, 'certificates')
      this.data.id_reference = idCert.id
      await updateCertificate(this.$fire, idCert.id, this.data, 'certificates')
      this.createCsv(this.data)
    },
    async getCertificateByLink() {
      this.loading = true
      if (this.$route.params.cert) {
        const uuid = this.$route.fullPath.split('/').slice(-1)
        await this.getJsonFile(uuid)
      }
    },
    getCertificate() {
      this.loading = true
      const self = this
      let matchProperty = 'id_user'
      let matchValue = this.userStore.uid
      if (this.$route.params.cert) {
        matchProperty = 'id_reference'
        matchValue = this.$route.params.cert
      }
      this.$fire.firestore
        .collection(this.firebaseCollection)
        .where(matchProperty, '==', matchValue)
        .onSnapshot(
          { includeMetadataChanges: true },
          (snapshot: any) => {
            if (!snapshot.empty) {
              snapshot.docs.forEach((doc: any) => {
                self.certificate = doc.data()
                // self.certificate.is_certified = certificate.is_certified
                if (self.certificate.is_certified) {
                  console.log(self.certificate.link.split('/').slice(-1))
                  const uuid = self.certificate.link.split('/').slice(-1)
                  self.getJsonFile(uuid)
                  self.loading = false
                }
              })
            } else if (this.refCertContributor) {
              this.certificateData()
              this.refCertContributor = false
            }
            snapshot.docChanges().forEach((change: any) => {
              const changeData = change.doc.data()
              if (change.type === 'modified') {
                if (changeData.estado_origen === 'Certificado') {
                  self.certificate = changeData
                  self.loading = false
                }
              }
            })
          },
          (error: any) => {
            console.error(error)
          }
        )
    },
    getJsonFile(uuid: Array<string>) {
      if (uuid.length > 0) {
        const idCert = uuid[0]
        const storageRef = this.$fireModule.storage().ref(`signed_mar_de_plata`)
        storageRef
          .child(`${idCert}.json`)
          .getDownloadURL()
          .then((url: string) => {
            this.urlFile = url
            const xhr = new XMLHttpRequest()
            xhr.responseType = 'json'
            xhr.open('GET', url)
            xhr.send()
            xhr.onload = () => {
              const json = xhr.response
              this.certificate = { ...this.certificate, ...json }
              this.certificate.issuerID = this.certificate.badge.issuer.id
              this.certificate.issuedOnFormat =
                this.certificate.issuedOn.split('T')[0]
              this.certificate.transactionIDURL =
                this.certificate.signature.anchors[0].sourceId
              this.certificate.chain =
                this.certificate.signature.anchors[0].chain.toUpperCase()
              this.certificate.hash = this.certificate.signature.targetHash
              this.certificate.uuid = idCert
              this.certificate.link = this.certificate.link
                ? this.certificate.link
                : `${window.location.origin}${this.$route.fullPath}`
              this.certificate.is_certified = true
            }
          })
          .catch((error: any) => {
            console.error(error)
          })
          .finally(() => {
            this.loading = false
          })
      }
    },
  },
})
</script>

<style scoped>
.template-boder {
  border: solid 3px var(--v-primary-base);
}
.relative {
  position: relative;
}
.height-full {
  height: 100%;
}
.info-json {
  background-color: var(--v-primary-base);
}

hr.verificationDivider {
  border-top: 1px dashed black;
}
</style>
